<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;
use HCM\Util\DateUtil;

class GpeSitufunch extends \Doctrine\ORM\EntityRepository {
    
    
    public function getAfastamentoIncideVale($competencia)
    {
        $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
        
        $params = array('p_dtmescompetenc' => $competencia);

        $sql = <<<SQL
SELECT GPE_SITUFUNCH.NRSITUFUNCM
FROM GPE_SITUFUNCH
WHERE GPE_SITUFUNCH.IDGERVALETRANSP = 'N'
    AND GPE_SITUFUNCH.DTEFETIVA = ( SELECT MAX(DTEFETIVA) DTEFETIVA
                                  FROM GPE_SITUFUNCH MAX_SITUFUNCH
                                  WHERE MAX_SITUFUNCH.DTEFETIVA <= :p_dtmescompetenc
                                      AND MAX_SITUFUNCH.NRSITUFUNCM = GPE_SITUFUNCH.NRSITUFUNCM)
ORDER BY 1
SQL;

        //$result = \Setforms2\Shared\Connection::getInstance()->fetchAll($sql);
        $resultado = $db->fetchAll($sql,$params);        
        
        $info = array();

        foreach($resultado as $res){
            $info[] = $res['NRSITUFUNCM'];
        }
        return $info;

    }

    public function getAlteSitufunc($dtmescompetenc, $nrorg, $nrsitufuncm) {
        $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
        
        $params = array(
            'P_DTMESCOMPETENC' => $dtmescompetenc,
            'P_NRORG'          => $nrorg,
            'P_NRSITUFUNCM'    => $nrsitufuncm
        );

        $sql = <<<SQL
SELECT *
FROM GPE_SITUFUNCH SFH
WHERE ( SFH.NRORG IS NULL OR SFH.NRORG = 0 OR SFH.NRORG = :P_NRORG )
    AND SFH.NRSITUFUNCM = :P_NRSITUFUNCM
    AND SFH.NRSITUFUNCM <> 13
    AND SFH.DTEFETIVA = (SELECT 
                           MAX(DTEFETIVA)
                         FROM GPE_SITUFUNCH
                         WHERE DTEFETIVA <= :P_DTMESCOMPETENC
                           AND ( SFH.NRORG IS NULL OR SFH.NRORG = 0 OR SFH.NRORG = :P_NRORG)
                           AND NRSITUFUNCM = SFH.NRSITUFUNCM )
    AND ROWNUM = 1
SQL;
    
        $resultado = $db->fetchAll($sql,$params);        

        return $resultado;

    }
    
}